#!/usr/bin/perl -I/usr/sausalito/perl

use Quota;
use CCE;

my $cce=new CCE;
$cce->connectuds();

my @userOids=$cce->find("User");
my $BLOCKS_PER_MB=1024;
my $skipped_items=0;
my $oid;
my $ok;

my ($user, $disk);
foreach $oid (@userOids){
    ($ok, $user) = $cce->get($oid);
    ($ok, $disk) = $cce->get($oid, "Disk");
    my ($uid,$dir)=(getpwnam($user->{name}))[2,7];
    unless(defined $uid && defined $dir){
	$skipped_items++;
	next;
    }
    my $dev=Quota::getqcarg($dir);
    if ($disk->{quota} == 0) {
	#set a 1kb quota
	Quota::setqlim($dev,$uid,1,1,1,1);
    } elsif ($disk->{quota} > 0) {
	my $hardQuota = ($disk->{quota}*$BLOCKS_PER_MB) + $BLOCKS_PER_MB;
	my $softQuota = ($disk->{quota}*$BLOCKS_PER_MB);
	Quota::setqlim($dev,$uid,$softQuota,$hardQuota,0,0);
    } else { #negative quota==no quota
	Quota::setqlim($dev,$uid,0,0,0,0);
    }
}

my @workgroupOids=$cce->find("Workgroup");

# the extra two parameters on the setqlim call are to make 
# it apply to groups.  the first one is documented, but
# the second one isn't.  it is 0=user, 1=group.

my ($workgroup);
foreach $oid (@workgroupOids){
    ($ok, $workgroup) = $cce->get($oid);
    ($ok, $disk) = $cce->get($oid, "Disk");
    my $gid=(getgrnam($workgroup->{name}))[2];
    unless(defined $gid){
	$skipped_items++;
	next;
    }
    my $dev=Quota::getqcarg("/home");
    if($disk->{quota} == 0){
	#set a 1kb quota
	Quota::setqlim($dev,$gid,1,1,1,1,0,1);
    }elsif($disk->{quota} > 0){
	my $hardQuota = ($disk->{quota}*$BLOCKS_PER_MB) + $BLOCKS_PER_MB;
	my $softQuota = ($disk->{quota}*$BLOCKS_PER_MB);
	Quota::setqlim($dev,$gid,$softQuota,$hardQuota,0,0,0,1);
    }else{ # negative quota==no quota
	Quota::setqlim($dev,$gid,0,0,0,0,0,1);
    }
}

if($skipped_items){
    $cce->bye("FAIL");
}else{
    $cce->bye("SUCCESS");
}
exit(0);
